/*
 *  Copyright (C) 2009  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef HC_CONN_INTERNAL_H
#define HC_CONN_INTERNAL_H

#include "hcconn.h"

struct _hc_conn_t
{
  HCClientFunc func;
  gpointer data;
  ssize_t (*read) (gpointer, char *, size_t);
  ssize_t (*write) (gpointer, char *, size_t);
  void (*close) (gpointer);
  gpointer layer;
};

ssize_t hc_conn_channel_read (gpointer, char *, size_t);
ssize_t hc_conn_channel_write (gpointer, char *, size_t);
void hc_conn_channel_close (gpointer);

#endif
